/*

        󑐋Z@ʃfBXvC̉p

        Copyright 2009-2011, Yoshi Hiroshi.

*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "uDisp.h"
#include "uDispControl.h"
#include "logCommand.h"
#include "simpleUart.h"
#include "scope.h"
#include "captureMode.h"
#include "switch.h"
#include "helper.h"

char capModeLabel0[] PROGMEM = "Capture Mode";
char capModeLabel1[] PROGMEM = "CONTINOUS";
char capModeLabel2[] PROGMEM = "SINGLE";

void showCaptureModePanel()
{
    uDispErase();
    uDispSetColourInt(MENU_COLOUR);
    uDispSetFontSize(UDISP_FONT_SIZE_LARGE);
    uDispDrawText_P(0, 0, capModeLabel0);
    uDispSetColour(0, 0, 255);
    uDispDrawLine(0,13, 127, 13);

    uDispSetColourInt(MENU_ITEM_COLOUR);
    uDispDrawText_P(2, 2, capModeLabel1);
    uDispDrawText_P(3, 2, capModeLabel2);
    dispSelect(lcb.captureMode + 2, 0);

    captureModeHelper();
    purgeSwitchReq();
}

char captureModeOperation()
{
    char result = 0;
    if(SW_IS_PUSH(SW_ZOOMIN)) {
        SW_ACK_PUSH(SW_ZOOMIN);
        if(lcb.captureMode < 1) {
            dispDeselect(lcb.captureMode + 2, 0);
            lcb.captureMode++;
            dispSelect(lcb.captureMode + 2, 0);
        }
    }
    if(SW_IS_PUSH(SW_ZOOMOUT)) {
        SW_ACK_PUSH(SW_ZOOMOUT);
        if(lcb.captureMode > 0) {
            dispDeselect(lcb.captureMode + 2, 0);
            lcb.captureMode--;
            dispSelect(lcb.captureMode + 2, 0);
        }
    }
    return result;
}
