/*

        󑐋Z@ʃfBXvC̉p

        Copyright 2009-2011, Yoshi Hiroshi.

*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "uDisp.h"
#include "uDispControl.h"
#include "logCommand.h"
#include "switch.h"
#include "scope.h"
#include "scrollWidth.h"
#include "helper.h"

char scrlWthTitle1[] PROGMEM = "Scroll Width";
char scrlWthTitle2[] PROGMEM = "1 DIV";
char scrlWthTitle3[] PROGMEM = "2 DIV";
char scrlWthTitle4[] PROGMEM = "3 DIV";

void showScrollWidthPanel()
{
    uDispErase();
    uDispSetColourInt(MENU_COLOUR);
    uDispSetFontSize(UDISP_FONT_SIZE_LARGE);
    uDispDrawText_P(0, 0, scrlWthTitle1);
    uDispSetColourInt(COLOUR_BLUE);
    uDispDrawLine(0,14, 127, 14);
    uDispSetColourInt(MENU_ITEM_COLOUR);
    uDispSetFontSize(UDISP_FONT_SIZE_LARGE);
    uDispDrawText_P(2, 2, scrlWthTitle2);
    uDispDrawText_P(3, 2, scrlWthTitle3);
    uDispDrawText_P(4, 2, scrlWthTitle4);
    dispSelect(lcb.scrollWidth + 2, 0);

    scrollWidthHelper();
    purgeSwitchReq();
}

char scrollWidthOperation()
{
    char result = 0;
    if(SW_IS_PUSH(SW_ZOOMIN)) {
        SW_ACK_PUSH(SW_ZOOMIN);
        if(lcb.scrollWidth < 2) {
            dispDeselect(lcb.scrollWidth + 2, 0);
            lcb.scrollWidth++;
            dispSelect(lcb.scrollWidth + 2, 0);
        }
    }
    if(SW_IS_PUSH(SW_ZOOMOUT)) {
        SW_ACK_PUSH(SW_ZOOMOUT);
        if(lcb.scrollWidth > 0) {
            dispDeselect(lcb.scrollWidth + 2, 0);
            lcb.scrollWidth--;
            dispSelect(lcb.scrollWidth + 2, 0);
        }
    }
    if(SW_IS_PUSH(SW_DOWN)) {
        SW_ACK_PUSH(SW_DOWN);
        result = lcb.scrollWidth + 1;
    }
    return result;
}

