/*

        󑐋Z@ʃfBXvC̉p

        Copyright 2009-2011, Yoshi Hiroshi.

 */

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdio.h>
#include <string.h>
#include "uDisp.h"
#include "uDispControl.h"
#include "simpleUart.h"
#include "switch.h"
#include "trigger.h"
#include "logCommand.h"
#include "helper.h"

char triggerTitle0[] PROGMEM = "Trig. & Capt.";
char triggerTitle1[] PROGMEM = "Enbl Hgh Low";
char triggerForm1[] PROGMEM = "ch.%d:";

volatile char selectedItem = 0;
volatile char selectedChannel = 0;

void showTrgLevel(unsigned char chnl)
{
    unsigned char x = 86;
    unsigned char y = chnl * 12 + 24;
    uDispSetColourInt(COLOUR_BLACK);
    uDispDrawRectangle(UDISP_RECT_FILL_ON, x, y, x + 44, y + 11);
    if(lcb.triggerMask & _BV(chnl)) {
        uDispSetColourInt(MENU_TRIG_HIGH_COLOUR);
        uDispDrawRectangle(UDISP_RECT_FILL_OFF, x + 1, y + 1, x + 10, y + 10);
        uDispSetColourInt(MENU_TRIG_LOW_COLOUR);
        uDispDrawRectangle(UDISP_RECT_FILL_OFF, x + 25, y + 1, x + 34, y + 10);
        if(lcb.triggerPattern & _BV(chnl)) {
            dispCheck(x, y, 1);
        } else {
            dispCheck(x + 22, y, 1);
        }
    } else {
        uDispSetColourInt(MENU_TRIG_HIGH_DARK_COLOUR);
        uDispDrawRectangle(UDISP_RECT_FILL_OFF, x + 1, y + 1, x + 10, y + 10);
        uDispSetColourInt(MENU_TRIG_LOW_DARK_COLOUR);
        uDispDrawRectangle(UDISP_RECT_FILL_OFF, x + 25, y + 1, x + 34, y + 10);
        if(lcb.triggerPattern & _BV(chnl)) {
            dispCheck(x, y, 0);
        } else {
            dispCheck(x + 24, y, 0);
        }
    }
}

void showTrgEnable(unsigned char chnl)
{
    unsigned char x = 60;
    unsigned char y = chnl * 12 + 24;
    uDispSetColourInt(COLOUR_BLACK);
    uDispDrawRectangle(UDISP_RECT_FILL_ON, x, y, x + 12, y + 11);
    uDispSetColourInt(MENU_ITEM_COLOUR);
    uDispDrawRectangle(UDISP_RECT_FILL_OFF, x + 1, y + 1, x + 10, y + 10);
    if(lcb.triggerMask & _BV(chnl)) {
        dispCheck(x, y, 1);
    }
    showTrgLevel(chnl);
}

void showHelp()
{
    uDispSetColourInt(COLOUR_BLACK);
    uDispDrawRectangle(UDISP_RECT_FILL_ON, 0, 96, 127, 127);
    switch(selectedItem) {
    case 0:
        triggerHelper();
        uDispSetColourInt(MENU_SELECT_ITEM_COLOUR);
        uDispDrawRectangle(UDISP_RECT_FILL_ON, 0, 98, 56, 100);
        break;
    case 1:
        triggerEnblHelper();
        uDispSetColourInt(MENU_SELECT_ITEM_COLOUR);
        uDispDrawRectangle(UDISP_RECT_FILL_ON, 55, 98, 76, 100);
        break;
    case 2:
        triggerLvlHelper();
        uDispSetColourInt(MENU_SELECT_ITEM_COLOUR);
        uDispDrawRectangle(UDISP_RECT_FILL_ON, 82, 98, 127, 100);
        break;
    }
}

void showTriggerPanel()
{
    uDispErase();
    uDispSetColourInt(MENU_COLOUR);
    uDispSetFontSize(UDISP_FONT_SIZE_LARGE);
    uDispDrawText_P(0, 0, triggerTitle0);
    uDispSetColour(0, 0, 255);
    uDispDrawLine(0,13, 127, 13);
    uDispSetColourInt(MENU_COLOUR);
    uDispSetFontSize(UDISP_FONT_SIZE_SMALL);
    uDispDrawText_P(2, 9, triggerTitle1);
    uDispSetFontSize(UDISP_FONT_SIZE_LARGE);

    CLEAR_KEY_BREAK_INT;
    CLEAR_KEY_BREAK;
    purgeSwitchReq();
    enableKeyBreak(1);
    for(char inx = 0; inx < 6; inx++) 
    {
        sprintf_P( strWork, triggerForm1, inx + 1);
        uDispSetColourInt(MENU_ITEM_COLOUR);
        uDispDrawText(inx + 2, 2, strWork);
        showTrgEnable(inx);
        if(IS_KEY_BREAK_INT) break;
    }
    enableKeyBreak(0);
    dispSelect(selectedChannel + 2, 0);
    showHelp();
}


char triggerOperation()
{
    char result = 0;
    if(SW_IS_PUSH(SW_ZOOMOUT)) {
        SW_ACK_PUSH(SW_ZOOMOUT);
        switch(selectedItem) {
        case 0:
            if(selectedChannel > 0) {
                dispDeselect(selectedChannel + 2, 0);
                selectedChannel--;
                dispSelect(selectedChannel + 2, 0);
            }
            break;
        case 1:
            if(lcb.triggerMask & _BV(selectedChannel)) {
            } else {
                lcb.triggerMask |= _BV(selectedChannel);
                showTrgEnable(selectedChannel);
            }
            break;
        case 2:
            if(lcb.triggerPattern & _BV(selectedChannel)) {
            } else {
                lcb.triggerPattern |= _BV(selectedChannel);
                showTrgLevel(selectedChannel);
            }
            break;
        }
    }
    if(SW_IS_PUSH(SW_ZOOMIN)) {
        SW_ACK_PUSH(SW_ZOOMIN);
        switch(selectedItem) {
        case 0:
            if(selectedChannel < 5) {
                dispDeselect(selectedChannel + 2, 0);
                selectedChannel++;
                dispSelect(selectedChannel + 2, 0);
            }
            break;
        case 1:
            if(lcb.triggerMask & _BV(selectedChannel)) {
                lcb.triggerMask &= ~_BV(selectedChannel);
                showTrgEnable(selectedChannel);
            } else {
            }
            break;
        case 2:
            if(lcb.triggerPattern & _BV(selectedChannel)) {
                lcb.triggerPattern &= ~_BV(selectedChannel);
                showTrgLevel(selectedChannel);
            } else {
            }
            break;
        }
    }
    if(SW_IS_PUSH(SW_LEFT)) {
        SW_ACK_PUSH(SW_LEFT);
        if(selectedItem > 0) {
            selectedItem--;
            showHelp();
        }
    }
    if(SW_IS_PUSH(SW_RIGHT)) {
        SW_ACK_PUSH(SW_RIGHT);
        if(selectedItem < 2) {
            selectedItem++;
            showHelp();
        }
    }
    if(SW_IS_PUSH(SW_UP)) {
        SW_ACK_PUSH(SW_UP);
        selectedItem = 0;
        result = 1;
    }
    return result;
}

