/*

        󑐋Z@ʃfBXvC̉p

        Copyright 2009-2011, Yoshi Hiroshi.

*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include "switch.h"

unsigned char switches[NUMSWITCHES];
unsigned int  switcheCount[NUMSWITCHES];

void initSwitchPort()
{
    DDRB &= 0xE0;
    PORTB = 0x1F;
    DDRD &= 0x3F;
    PORTD |= 0xC0;
}

void initSwitch()
{
    initSwitchPort();
    unsigned val = getSwitchValue();
    for(int inx = 0; inx < NUMSWITCHES; inx++) {
        switches[inx] = 0;
        if(val & _BV(inx)) {
            switches[inx] |= _BV(SW_ACT_PREV);
        } else {
            switches[inx] &= ~_BV(SW_ACT_PREV);
        }
    }
}

void waitForAllKeyRelease()
{
    while(getSwitchValue());
}

void purgeSwitchReq()
{
    for(int inx = 0; inx < NUMSWITCHES; inx++) {
        SW_ACK_ALL(inx);
    }
}

unsigned char getSwitchValue()
{
    unsigned char val = PINB & 0x1F;
    unsigned char vald = PIND & 0xC0;
    val |= (vald >> 1) | 0x80;
    return ~val;
}

void checkSwitches()                      // process every 1mS
{
    initSwitchPort();
    unsigned val = getSwitchValue();
    for(int inx = 0; inx < NUMSWITCHES; inx++) {
        checkSwitchStatus((val & _BV(inx)), inx);
    }
}

unsigned char switchInPush(unsigned char swInx)
{
    if((switches[swInx] & (_BV(SW_ACT_PREV) | _BV(SW_ACT_CURR))) == (_BV(SW_ACT_PREV) | _BV(SW_ACT_CURR))) {
        if(switcheCount[swInx] >= SW_ON_DELAY) {
            return 1;
        }
    }
    return 0;
}

unsigned char switchInLong(unsigned char swInx)
{
    if((switches[swInx] & (_BV(SW_ACT_PREV) | _BV(SW_ACT_CURR))) == (_BV(SW_ACT_PREV) | _BV(SW_ACT_CURR))) {
        if(switcheCount[swInx] >= SW_LONG_DELAY) {
            return 1;
        }
    }
     return 0;
}

unsigned char switchInRel(unsigned char swInx)
{
    if(((switches[swInx] & (_BV(SW_ACT_PREV) | _BV(SW_ACT_CURR))) == 0)) {
        return 1;
    }
     return 0;
}

void checkSwitchStatus(unsigned char currVal, unsigned char swInx)
{
    unsigned char* sw = &switches[swInx];
    unsigned int* swCount = &switcheCount[swInx];
    if(currVal) {                           // ݒl[N̈Ɉڂ
        *sw |= _BV(SW_ACT_CURR);
    } else {
        *sw &= ~_BV(SW_ACT_CURR);
    }
    if((*sw & _BV(SW_ACT_CURR)) && (*sw & _BV(SW_ACT_PREV))) {  // no change ?
        if((*swCount)++ >= 1000) *swCount = 1000;     // ԃJE^̍XV
        if(*swCount == SW_ON_DELAY) {                   // Ԍo
            *sw |= _BV(SW_ACT_PUSH);                    //  PUSHꂽƔF
            *sw &= ~_BV(SW_ACT_RELEASE);                //  RELEASEtO|
        }

        if(*swCount == SW_LONG_DELAY) {                 // Ԍo
            *sw |= _BV(SW_ACT_LONG);                    //  LONGtOZbg
            *sw &= ~_BV(SW_ACT_RELEASE);                //  RELEASEtO|
        }

        if(*swCount == SW_REPEAT_CYCLE_DELAY) {         // Ԍo
            *sw |= _BV(SW_ACT_REPEAT);                  //  REPEATtOZbg
            *swCount = SW_REPEAT_START_DELAY;
        }

    } else {                                            // changed?
        if(*swCount >= SW_ON_DELAY) {                   // 
            if((*sw & _BV(SW_ACT_CURR)) == 0) {         //  @ꂽH
                *sw |= _BV(SW_ACT_RELEASE);             //  RELEASEtOZbg
            }
        }
        *swCount = 0;
        if(*sw & _BV(SW_ACT_CURR)) {
            *sw |= _BV(SW_ACT_PREV);
        } else {
            *sw &= ~_BV(SW_ACT_PREV);
        }
    }
}

