/*

        󑐋Z@ʃfBXvC̉p

        Copyright 2009-2011, Yoshi Hiroshi.

*/

#define SW_ON_DELAY                 50       // 1ms x 50
#define SW_LONG_DELAY               1000     // 1ms x 1000
#define SW_REPEAT_START_DELAY       1250     // 1ms x 1250
#define SW_REPEAT_CYCLE_DELAY       1300     // 1ms x 1300

#define NUMSWITCHES                 7
extern unsigned char switches[NUMSWITCHES];

/*
        Switchs
 */
#define SW_MOTION                   (0)
#define SW_ZOOMOUT                  (1)
#define SW_ZOOMIN                   (2)
#define SW_LEFT                     (3)
#define SW_RIGHT                    (4)
#define SW_UP                       (5)
#define SW_DOWN                     (6)

/*
        Switch operation common

 */
#define SW_ACT_PUSH                 1
#define SW_ACT_LONG                 2
#define SW_ACT_REPEAT               3
#define SW_ACT_RELEASE              4
#define SW_ACT_PREV                 6
#define SW_ACT_CURR                 7

#define SW_IS_PUSH(swInx)           (switches[swInx] & _BV(SW_ACT_PUSH))
#define SW_IS_LONG(swInx)           (switches[swInx] & _BV(SW_ACT_LONG))
#define SW_IS_REPEAT(swInx)         (switches[swInx] & _BV(SW_ACT_REPEAT))
#define SW_IS_REL(swInx)            (switches[swInx] & _BV(SW_ACT_RELEASE))
#define SW_ACK_PUSH(swInx)          (switches[swInx] &= ~_BV(SW_ACT_PUSH))
#define SW_ACK_LONG(swInx)          (switches[swInx] &= ~_BV(SW_ACT_LONG))
#define SW_ACK_REPEAT(swInx)        (switches[swInx] &= ~_BV(SW_ACT_REPEAT))
#define SW_ACK_REL(swInx)           (switches[swInx] &= ~_BV(SW_ACT_RELEASE))
#define SW_ACK_ALL(swInx)           (switches[swInx] &= ~(_BV(SW_ACT_PUSH) | _BV(SW_ACT_LONG) | _BV(SW_ACT_REPEAT) | _BV(SW_ACT_RELEASE)))
#define SW_IN_PUSH(swInx)           (switchInPush(swInx))
#define SW_IN_LONG(swInx)           (switchInLong(swInx))
#define SW_IN_REL(swInx)            (switchInRel(swInx))

void initSwitchPort();
void initSwitch();
void waitForAllKeyRelease();
void purgeSwitchReq();
unsigned char getSwitchValue();
unsigned char switchInPush(unsigned char swInx);
unsigned char switchInLong(unsigned char swInx);
unsigned char switchInRel(unsigned char swInx);
void checkSwitches();
void checkSwitchStatus(unsigned char currVal, unsigned char swInx);
